// lib/download.js

const chalk = require('chalk') // 修改控制台中字符串的样式
const log = ctx => console.log(chalk.green(ctx)) // 封装日志输出
const child_process = require("child_process");
const { spawn } = child_process

/**
 * repo 下载的模板路径
 * desc 下载的目标路径地址
 */
module.exports.clone = function (repo, desc) {
	const ora = require('ora')
	const process = ora(`⏳下载...... ${repo}`) // 用于显示加载效果，类似页面的 loading 效果
	process.start()
	return new Promise((resolve, reject) => {
		const proc = spawn('git', ["clone", "-b", "master", repo, desc])
		proc.stdout.on("data", function (data) {
			log("data:", data)
			process.succeed()
		})

		proc.stderr.on("data", function (err) {
			log("download err,", err)
			process.succeed()
		})

		proc.on('close', resolve)
	})

}