// 封装 spawn 命令
// 子进程输出流引入主进程输出流

module.exports = async (...args) => {
	const { spawn } = require('child_process')

	const options = args[args.length - 1]
	// 如果系统为windows，则需要修改 shell 为 true
	if (process.platform === 'win32') {
		// 设置 shell 为 true，以隐式的调用 cmd
		options.shell = true
	}

	return new Promise(resolve => {
		const proc = spawn(...args)
		// proc(子) -> process(主)
		proc.stdout.pipe(process.stdout) // 标准输出
		proc.stderr.pipe(process.stderr) // 标准错误输出
		proc.on('close', resolve)
	})
}